% This is the accompanying software of the paper "A Vision-based Technique for Circle Detection and Measurement Using Look-up Table and Bitwise Center Accumulator"(LUT-BCA)
% Authors:  Hancheng Yu and Tuo Wang

close all;
clear all;
 
%FileName ='images\plates.bmp';
%FileName='images\Swatch.jpg';
%FileName ='images\LOGO.jpg';
FileName ='images\Drain Cover.jpg';


% Read image
Image = (imread(FileName));
[m n l] = size(Image);
if ( l == 3 )
    Image = rgb2gray((Image));
end;

% Load look-up table
load('cir_LUT_j.mat');
load('cir_LUT_i.mat');
load('cir_LUT_angle.mat');

% Locate circle centers and compute their radii
min_R = single(10);   % 10 is the minimum radius 
max_R = single(170); % 100 -- 300 the maximum radius 
tic;
[Center_radius,S,Edge]= LUT_BCA(Image,max_R,min_R,cir_LUT_i,cir_LUT_j,cir_LUT_angle); % S:The number of the normal lines through the point
time = toc

% Draw circles on the image
[D(:,:,1),D(:,:,2),D(:,:,3)] = draw_circle_tab(Image,Center_radius,cir_LUT_i,cir_LUT_j,cir_LUT_angle);

% Display images
figure('NumberTitle', 'off', 'Name', 'Detected circles'), imshow(uint8(D));
figure('NumberTitle', 'off', 'Name', 'Original Image'), imshow(uint8(Image));
figure('NumberTitle', 'off', 'Name', 'Edge map and coded normal lines'), imshow(uint8(Edge*255)+uint8(4*S));
